bin/mdw-build: Do all of the log descriptor setting in one place.
[profile] / bin / mdw-build
CommitLineData
7ee12623
MW
1#! /bin/bash
2###
3### Build script for Debian packages
4###
5### (c) 2008 Mark Wooding
6###
7
8###----- Licensing notice ---------------------------------------------------
9###
10### This program is free software; you can redistribute it and/or modify
11### it under the terms of the GNU General Public License as published by
12### the Free Software Foundation; either version 2 of the License, or
13### (at your option) any later version.
14###
15### This program is distributed in the hope that it will be useful,
16### but WITHOUT ANY WARRANTY; without even the implied warranty of
17### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
18### GNU General Public License for more details.
19###
20### You should have received a copy of the GNU General Public License
21### along with this program; if not, write to the Free Software Foundation,
22### Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
23
85b7c21c
MW
24###--------------------------------------------------------------------------
25### Conventions for build systems.
26###
27### This script is designed to work with a variety of `make'-based build
28### systems, but there are a number of conventions which must be followed if
29### this is going to work properly.
30###
31### * There must be a `configure.ac', `configure.in', or `.links' file, or
32### a `.git' directory in the project top-level, so that we can find it.
33###
34### * The following `make' variables must be assigned in the top-level
35### Makefile, after `mdw-build' has constructed it.
36###
37### distdir The name of the top-level project directory in the
38### source distribution, and the base name for
39### distribution archives; should be of the form
40### `PROJECT-VERSION'.
41###
42### The following `make' targets must be available in the top-level
43### Makefile.
44###
45### dist Write to $(distdir).tar.gz a source distribution of
46### the package.
47###
48### distcheck As for `dist', but also build and test the project.
49###
50### * The source distribution constructed by `make dist' must contain a file
51### $(distdir)/RELEASE containing the release name. This isn't currently
52### tested, but it might be later.
53
7ee12623
MW
54set -e
55
56###--------------------------------------------------------------------------
816af8ee
MW
57### Configuration.
58
59unset checkout checkoutrev
60unset setup setupcmd
5a91acc5 61unset sign signkey
b94830d9 62unset sbuild sbuildsrv
5a91acc5 63unset upload uploadpath
816af8ee 64unset dput dputtarget
5a91acc5 65unset build distcheck debian clean vpath native
816af8ee
MW
66for i in \
67 "/etc/mdw-build.conf" \
68 "${XDG_CONFIG_HOME-$HOME/.config}/mdw-build.conf" \
69 "./.mdw-build.conf"
70do
71 if [ -f "$i" ]; then . "$i"; fi
72done
5a91acc5
MW
73default_depends () {
74 var=$1 want=$2
75 eval "p=\${$var+t} q=\${$want+t}"
76 case $p,$q in t,*) ;; *,t) eval "$var=yes" ;; *) eval "$var=no" ;; esac
77}
816af8ee
MW
78: ${checkout=yes} ${checkoutrev=HEAD}
79: ${build=test}
80: ${setup=yes} ${setupcmd=mdw-setup}
81: ${distcheck=yes}
82: ${debian=yes}
816af8ee
MW
83: ${clean=yes}
84: ${vpath=yes}
85: ${native=yes}
ac504698 86: ${make=make}
b94830d9 87default_depends sbuild sbuildsrv
5a91acc5
MW
88default_depends sign signkey
89default_depends upload uploadpath
90default_depends dput dputtarget
816af8ee
MW
91: ${DEB_BUILD_OPTIONS=parallel=4}; export DEB_BUILD_OPTIONS
92
93###--------------------------------------------------------------------------
7ee12623
MW
94### Parse options.
95
0660d224
MW
96prog=${0##*/}
97
7ee12623
MW
98usage () {
99 cat <<EOF
24a3095a 100Usage: $prog [-v] BUILDOPT
7ee12623
MW
101
102Build options:
103
104 [no]checkout[=REV]
105 [no]release
9c586ae1 106 [no]setup[=RUNE]
7ee12623
MW
107 [no]distcheck
108 [no]debian
5a91acc5
MW
109 [no]upload[=SERVER:PATH]
110 [no]dput[=TARGET]
7ee12623 111 [no]clean
f5b3423e 112 [no]vpath
b94830d9 113 [no]sbuild[=SERVER]
5a91acc5 114 [no]sign[=KEYID]
d87d7867 115 [no]native
ac504698 116 make=MAKE
7ee12623
MW
117EOF
118}
119
120## Parse simple options.
121verbose=no
24a3095a 122while getopts "hv" opt; do
7ee12623
MW
123 case "$opt" in
124 h) usage; exit 0 ;;
125 v) verbose=yes ;;
126 *) exit 1 ;;
127 esac
128done
129shift $((OPTIND - 1))
130
131## Parse the build options.
5a91acc5
MW
132maybe_set () {
133 var=$1 want=$2
134 eval "p=\${$want+t}\${$want-nil}"
135 case $p in
136 t) eval $var=yes ;;
137 nil) echo >&2 "$prog: $want not set"; exit 1 ;;
138 esac
139}
7ee12623
MW
140for opt; do
141 case "$opt" in
142 checkout) checkout=yes checkoutrev=HEAD ;;
143 checkout=*) checkout=yes checkoutrev=${opt#*=} ;;
7ee12623
MW
144 release) build=release ;;
145 norelease) build=test ;;
9c586ae1
MW
146 setup) setup=yes setupcmd=mdw-setup ;;
147 setup=*) setup=yes setupcmd=${opt#*=} ;;
5a91acc5
MW
148 upload) maybe_set upload uploadpath ;;
149 upload=*) upload=yes uploadpath=${opt#*=} ;;
150 sign) maybe_set sign signkey ;;
151 sign=*) sign=yes signkey=${opt#*=} ;;
b94830d9
MW
152 sbuild) maybe_set sbuild sbuildsrv ;;
153 sbuild=*) sbuild=yes sbuildsrv=${opt#*=} ;;
5a91acc5
MW
154 dput) maybe_set dput dputtarget ;;
155 dput=*) dput=yes dputtarget=${opt#*=} ;;
ac504698 156 make=*) make=${opt#*=} ;;
5a91acc5
MW
157
158 distcheck | debian | clean | vpath | native)
7ee12623
MW
159 eval "$opt=yes"
160 ;;
50c72b0f 161 nocheckout | nosetup | nodistcheck | nodebian | \
b94830d9 162 noupload | nodput | noclean | novpath | nonative | nosbuild | nosign)
7ee12623
MW
163 eval "${opt#no}=no"
164 ;;
165 *)
166 usage >&2
167 exit 1
168 ;;
169 esac
170done
171
84dd9069
MW
172## Parse DEB_BUILD_OPTIONS.
173jobs=1
174set -- $DEB_BUILD_OPTIONS
175for opt; do
176 case "$opt" in
177 parallel=*) jobs=${opt#*=} ;;
178 esac
179done
180
181makeopts=""
182case $jobs in 1) ;; *) makeopts="$makeopts -j$jobs" ;; esac
183
7ee12623
MW
184###--------------------------------------------------------------------------
185### Utility functions.
186
190c1efc
MW
187## File descriptor assignments:
188##
189## 0 -- original stdin (never touched)
190## 1, 2 -- stdout, stderr, redirected to 3 while running comamnds
ab9fae2a 191## log -- original stderr (verbose), or logfile (quiet); captures command
190c1efc 192## output
ab9fae2a
MW
193## diag -- null (verbose), or logfile (quiet); primary diagnostic output
194## term -- orginal stderr; secondary diagnostic output (with colours)
190c1efc 195
7ee12623
MW
196notify () {
197 colour=$1 message=$2
ab9fae2a
MW
198 echo $message >&$diag
199 echo "$(tput bold; tput setaf $colour)$message$(tput sgr0; tput op)" >&$term
7ee12623
MW
200}
201
202fail () {
203 notify 1 "!!! $*"
204 exit 1
205}
206
f282ba46
MW
207warn () {
208 case $build in
209 release) fail "$*" ;;
210 *) notify 5 "??? $*" ;;
211 esac
212}
213
7ee12623
MW
214info () {
215 notify 6 "--- $*"
216}
217
218assign () {
219 info "$1 = $2"
220 eval "$1=$2"
221}
222
223runx () {
224 notify 2 "+++ $*"
5b950572 225 nice "$@" 2>&$log {log}>&- {diag}>&- {term}>&- || fail "$1: exit $?"
7ee12623
MW
226}
227
ab9fae2a 228run () { runx "$@" >&$log; }
7ee12623
MW
229
230yesno () {
ab9fae2a
MW
231 echo -n "(test $*)" >&$diag
232 if "$@" >&$diag 2>&$diag {log}>&- {diag}>&- {term}>&-; then
233 echo "(yes)" >&$diag
7ee12623
MW
234 echo yes
235 else
ab9fae2a 236 echo "(no)" >&$diag
7ee12623
MW
237 echo no
238 fi
239}
240
241###--------------------------------------------------------------------------
242### Do the building.
243
244## Find the top-level package directory.
d43de82b
MW
245while [ ! -f configure.ac -a ! -f configure.in -a \
246 ! -f .links -a ! -d .git ]; do
7ee12623
MW
247 case "$(pwd)" in
248 /)
249 fail "couldn't find top-level directory"
250 ;;
251 esac
252 cd ..
253done
c3a2e2b1 254toppath=$(pwd)
7ee12623 255
9243a740
MW
256## Build any necessary qualifiers.
257qual= sep=.
258case ${SBOX_SESSION_DIR+t},${DEB_BUILD_ARCH+t} in
259 t,t) qual=$qual$sep$DEB_BUILD_ARCH; sep=- ;;
260 t,*) fail "unknown build arch" ;;
261esac
262
7ee12623 263## Construct the output directory.
c3a2e2b1 264releasepath=$toppath/dist-$build$qual
47539e6a 265chmod -R +w $releasepath 2>/dev/null || :
7ee12623
MW
266rm -rf $releasepath 2>/dev/null || :
267mkdir $releasepath
5043931a 268exec {term}>&2
7ee12623
MW
269case $verbose in
270 no)
ab9fae2a 271 exec {diag}>$releasepath/mdw-build.log {log}>&$diag ||
7ee12623
MW
272 fail "Failed to create log."
273 ;;
5043931a
MW
274 yes)
275 exec {diag}>/dev/null {log}>&2
276 ;;
7ee12623
MW
277esac
278
c3a2e2b1
MW
279## Repeat the earlier assignments for tbe benefit of the logfile.
280assign toppath $toppath
281assign releasepath $releasepath
282
f282ba46 283## Do we have a Git repository?
be2a2314 284case "$checkout,$setup,$(yesno [ -d $toppath/.git ])" in
7ee12623
MW
285 yes,no,*)
286 fail "Inconsistent options: can't check out without setup."
287 ;;
288 yes,yes,no)
289 info "No Git repository found."
f282ba46 290 checkout=no gitver=none
7ee12623
MW
291 ;;
292 yes,yes,yes)
be2a2314 293 cd $toppath
7ee12623 294 [ "$(git ls-files -m)" = "" ] ||
f282ba46 295 warn "working tree has uncommitted changes"
66305913 296 ;;
f282ba46
MW
297esac
298
299## Is there Debian build equipment?
be2a2314 300case "$debian,$(yesno [ -d $toppath/debian ])" in
f282ba46
MW
301 yes,no)
302 info "No debian directory found."
303 debian=no debver=none
304 ;;
f0905f8c
MW
305 no,*)
306 debver=none
307 ;;
f282ba46 308 yes,yes)
ac1bda22 309 debver=$(dpkg-parsechangelog | sed -n 's/^Version: //p')
40196145
MW
310 debsrc=$(dpkg-parsechangelog | sed -n 's/^Source: //p')
311 debname=$(git config user.name) debemail=$(git config user.email)
f282ba46
MW
312 ;;
313esac
314
46fced9d
MW
315## Maybe check out a copy of the source.
316case "$checkout" in
317 yes)
318 cd $releasepath
be2a2314 319 run git clone -sn $toppath/.git _source
46fced9d
MW
320 assign srcpath $releasepath/_source
321 cd $srcpath
493856f1
MW
322 run git update-ref refs/heads/mdw-build $checkoutrev ""
323 run git symbolic-ref HEAD refs/heads/mdw-build
324 run git read-tree --reset refs/heads/mdw-build
325 run git checkout-index -afu
ac1bda22 326 assign gitversion "$(git describe --abbrev=4)"
46fced9d 327 ;;
be2a2314
MW
328 no)
329 assign srcpath $toppath
330 ;;
46fced9d
MW
331esac
332
f282ba46 333## Check the version number.
40196145 334hack_dch_p=no
ac1bda22 335case "$gitversion,$debver" in
f282ba46
MW
336 none,* | *,none)
337 ;;
338 *)
ac1bda22
MW
339 dvref=$(echo "$debver" | tr '~' '_')
340 if [ "$gitversion" = "$dvref" ]; then
341 assign debversion "$debver"
342 else
343 warn "Git version $gitversion doesn't match Debian version $debver"
40196145 344 hack_dch=yes
ac1bda22
MW
345 dver=$(echo $gitversion | sed 's/-/+/; s/-/./g')
346 case $debver in *~) dver=$debver$dver ;; esac
347 assign debversion "$dver"
348 now=$(date -R)
40196145 349 fi
f282ba46
MW
350 ;;
351esac
352
7ee12623
MW
353## Maybe refresh the build machinery.
354case "$setup" in
355 yes)
9c586ae1 356 run $setupcmd
7ee12623
MW
357 ;;
358esac
359
360## Initialize the build directory.
f5b3423e
MW
361case "$vpath,$(yesno [ -e $srcpath/configure ])" in
362 yes,yes)
363 assign buildpath $releasepath/_build
364 mkdir $buildpath
365 cd $buildpath
366 run $srcpath/configure
367 ;;
368 no,yes)
369 info "VPATH build disabled"
370 assign buildpath $srcpath
371 distcheck=no
372 cd $srcpath
373 run ./configure
374 ;;
375 *,no)
376 info "no configure script"
377 assign buildpath $srcpath
378 cd $srcpath
379 ;;
380esac
7ee12623
MW
381
382## Discover the release name.
383cat >find-distdir.mk <<'EOF'
384include Makefile
385print-distdir:
ab9fae2a 386 @echo >&$(fd) $(distdir)
7ee12623 387EOF
dd8d9a6c 388assign distdir \
ab9fae2a 389 $({ $make -f find-distdir.mk print-distdir fd=$t >/dev/null 2>&1; } {t}>&1)
7ee12623
MW
390
391## Get a tarball distribution.
392case "$distcheck" in
393 yes)
ac504698 394 run $make $makeopts distcheck
7ee12623
MW
395 ;;
396 no)
ac504698 397 run $make $makeopts dist
7ee12623
MW
398 ;;
399esac
400
401cd $releasepath
402
d87d7867
MW
403case $native in
404 yes)
405 if ! tar tf $buildpath/$distdir.tar.gz 2>/dev/null | grep -q RELEASE
406 then
407 fail "missing RELEASE file in distribution"
408 fi
409 ;;
410esac
7ee12623
MW
411
412run mv $buildpath/$distdir.tar.gz .
5a91acc5
MW
413case $build,$sign in
414 release,yes)
415 run gpg -u$signkey -ab -o$distdir.tar.gz.gpg $distdir.tar.gz
47f56ea2
MW
416 ;;
417esac
7ee12623
MW
418
419## Maybe build the Debian packages.
f282ba46
MW
420case "$debian" in
421 yes)
7ee12623
MW
422 run tar xvfz $distdir.tar.gz
423 cd $distdir
40196145
MW
424 case $hack_dch in
425 yes)
40196145 426 cat - debian/changelog >debian/changelog.new <<EOF
ac1bda22 427$debsrc ($debversion) experimental; urgency=low
40196145
MW
428
429 * Hacking in process, not intended for release.
430
431 -- $debname <$debemail> $now
432
433EOF
434 mv debian/changelog.new debian/changelog
435 ;;
436 esac
e5099dd8
MW
437 sbuildargs=$sbuildsrv
438 case $sbuild,$build in
439 yes,release)
440 case $sign in yes) sbuildargs="-k$signkey $sbuildargs" ;; esac
441 ;;
6cf97414
MW
442 yes,*)
443 if [ -d $toppath/dist-$build.pkgs ]; then
444 sbuildargs="-p$toppath/dist-$build.pkgs $sbuildargs"
445 fi
446 ;;
e5099dd8 447 esac
b94830d9 448 case $sbuild,$build,$sign in
e5099dd8 449 yes,*) run mdw-sbuild $sbuildargs ;;
b94830d9 450 no,release,yes) run dpkg-buildpackage -k$signkey ;;
5a91acc5
MW
451 no,*) run dpkg-buildpackage -us -uc ;;
452 esac
7ee12623
MW
453 ;;
454esac
455
456## Maybe upload Debian packages.
457cd $releasepath
458case "$upload,$build" in
5a91acc5
MW
459 yes,test) info "Test build: not uploading." ;;
460 yes,release) run rsync $distdir.tar.gz $distdir.tar.gz.gpg $uploadpath ;;
461esac
462case "$debian,$upload,$dput,$build" in
463 yes,yes,yes,release) run dput -f $dputtarget *.changes ;;
7ee12623
MW
464esac
465
466## Tidy up.
467case "$clean" in
468 yes)
469 rm -rf $releasepath/$distdir
470 rm -rf $releasepath/_source
471 rm -rf $releasepath/_build
472 ;;
473esac
474
475## Done.
476info "All OK."
477
478###----- That's all, folks --------------------------------------------------